#include "mbed.h"
#include "TSISensor.h"

TSISensor tsi;

DigitalOut z7(PTC7,1);
DigitalOut z6(PTC6,1);
DigitalOut z5(PTC5,1);
DigitalOut z4(PTC4,1);
DigitalOut z3(PTC3,1);
DigitalOut z2(PTC2,1);
DigitalOut z1(PTC1,1);
DigitalOut z0(PTC0,1);

DigitalOut c7(PTC17,1);
DigitalOut c6(PTC16,1);
DigitalOut c5(PTC13,1);
DigitalOut c4(PTC12,1);
DigitalOut c3(PTC11,1);
DigitalOut c2(PTC10,1);
DigitalOut c1(PTC9,1);
DigitalOut c0(PTC8,1);

DigitalOut A(PTB0,1);
DigitalOut B(PTB1,1);
DigitalOut C(PTB2,1);

DigitalIn left(PTE0);
DigitalIn right(PTE1);
DigitalIn up(PTD6);
DigitalIn down(PTD7);

AnalogIn ran(PTB3);

bool had[8][8];     //pole souradnic hada na displeji
bool hlava[8][8];   //pole souradnice hlavy hada na displeji
bool jablko[8][8];  //pole souradnice jablka na displeji 
unsigned char size = 3, ja, s=2;     //velikost hada, pozice jablka, skore
unsigned char h[65],hh[65];       //pozice hada, pomcná promena
unsigned char posun = 0;      //chovani smeru pohybu 0 - doleva, 1 -doprava, 2 - dolu, 3 - nahoru

void tlac()     //zaznamenani stisku tlacitka a nastaveni prislusneho smeru pohybu
{
  if (up == 0 && posun !=2)
    posun = 3;
  if(down == 0 && posun != 3)
    posun = 2;
  if (left == 0 && posun != 1)
    posun = 0;
  if (right == 0 && posun != 0)
    posun =1;
}

char konec()     //vyhodnoceni zda had nekousnul do sebe
{
  unsigned char i,q = 1;     //pomocna, priznak zakousnuti
  
  for(i=1;i<=63;i++){       //testuji zda hlava na pozici h[0] kousla do tela
    if(h[0] == h[i])
      q=0;
  }
  return q;     // pokud se had kousne vratim 0 a vypadnu ze smycky while
}

void genj()      // funkce generujici pozici jablka
{
  unsigned char i;       // pomocna
  
  ja = rand() % 64;     //pozice jablka od 0 do 63
  for(i = 0;i<=63;i++){     //kontrola zda neni jablko v hadovi
    if(h[i] == ja){
      ja = rand() % 64;
      i = 0;
    }
  }
  s++;      // pricteni jablka do skore - o jedno spozdeno 
}

void chlamst()      //had snedl jablko
{
  if(h[0] == ja){       // pokud se rovnaji pozice hlavy hada a jablka dojde k vygenerovani noveho jablka a zvetseni hada o 1
    genj();
    size++; 
  }
}
    
void nuldisp()      //nulovani zobrazovacich matic hada, jablka a hlavy
{
  unsigned char i,j;
  for(i = 0; i < 8; i++){
    for(j=0;j<8;j++){
      had[i][j] = 1;
      hlava[i][j] = 1;
      jablko[i][j] = 1;
    }
  }
}

void dejmat()       // prepocet pracovnich souradnic na souradnice na dipleji
{
   unsigned char i,t1,t2;
  for(i = 0; i <= 65; i++){
    if(h[i] != 65){
      t1 = h[i] % 8;        //sloupek
      t2 = h[i] / 8;        //radek
      had[t2][t1] = 0;      //vlozeni priznaku o pritomnosti do matice
    }
  }
  t1 = h[0] % 8;
  t2 = h[0] / 8;
  hlava[t2][t1] = 0;
  t1 = ja % 8;
  t2 = ja / 8;
  jablko[t2][t1] = 0;
}

void pohyb()     //pohyb hada v pracovnich souradnicich h[]
{
  unsigned char i;
  switch (posun){       //na zaklade velikosti posunu rozhodne o smeru, funkce v case jsou temer totozne
    case 0:
      if(h[0]==7 || h[0]==15 || h[0]==23 || h[0]==31 || h[0]==39 || h[0]==47 || h[0]==55 || h[0]==63){      //osetreni projeti hada okrajem
    for(i=0;i<size-1;i++){      //vytvoreni kopie hada
      hh[i]=h[i];
        }
        for(i=0;i<size-1;i++){      // ulozeni kopie hada s posunutim
      h[i+1]=hh[i];
        }
        h[0]=h[0]-7;        //posunuti hlavy
    break;
    
      }else{                //stejne jako nahore jen bez prestupu krajem obrazovky
    for(i=0;i<size-1;i++){
      hh[i]=h[i];
        }
        for(i=0;i<size-1;i++){
      h[i+1]=hh[i];
        }
        h[0]=h[0]+1;
        break;
        }

    case 1:
      if(h[0]==0 || h[0]==8 || h[0]==16 || h[0]==24 || h[0]==32 || h[0]==40 || h[0]==48 || h[0]==56){
        for(i=0;i<size-1;i++){
      hh[i]=h[i];
        }
        for(i=0;i<size-1;i++){
          h[i+1]=hh[i];
        }
        h[0]=h[0]+7;
        break;
         
      }else{
    for(i=0;i<size-1;i++){
      hh[i]=h[i];
        }
        for(i=0;i<size-1;i++){
      h[i+1]=hh[i];
    }
        h[0]=h[0]-1;
    break;
      }
    case 2:
      if(h[0]==0 || h[0]==1 || h[0]==2 || h[0]==3 || h[0]==4 || h[0]==5 || h[0]==6 || h[0]==7){
        for(i=0;i<size-1;i++){
      hh[i]=h[i];
        }
        for(i=0;i<size-1;i++){
      h[i+1]=hh[i];
        }
        h[0]=h[0]+56;
        break;
      }else{
    for(i=0;i<size-1;i++){
      hh[i]=h[i];
        }
        for(i=0;i<size-1;i++){
      h[i+1]=hh[i];
        }
        h[0]=h[0]-8;
        break;
        }
    case 3:
      if(h[0]==56 || h[0]==57 || h[0]==58|| h[0]==59 || h[0]==60 || h[0]==61 || h[0]==62 || h[0]==63){
        for(i=0;i<size-1;i++){
      hh[i]=h[i];
        }
        for(i=0;i<size-1;i++){
      h[i+1]=hh[i];
        }
        h[0]=h[0]-56;
        break;
        
      }else{
        for(i=0;i<size-1;i++){
      hh[i]=h[i];
        }
        for(i=0;i<size-1;i++){
      h[i+1]=hh[i];
        }
        h[0]=h[0]+8;
        break;
    }
    }
  nuldisp();        //volani vynulovani displeje
}

void ukaz()     //funkce zobrazeni zobrazovacich souradnic na displej provede několik zobrazeni po sobe
{
   unsigned char i,j;
  for(i = 0; i < 8; i++){
    for(j=0;j<8;j++){       // pro zamezeni blikani
      if(i == 0){
    A=1;B=1;C=1;
        c0=had[i][0];c1=had[i][1];c2=had[i][2];c3=had[i][3];c4=had[i][4];c5=had[i][5];c6=had[i][6];c7=had[i][7];
        z0=jablko[i][0]*hlava[i][0];z1=jablko[i][1]*hlava[i][1];z2=jablko[i][2]*hlava[i][2];z3=jablko[i][3]*hlava[i][3];z4=jablko[i][4]*hlava[i][4];z5=jablko[i][5]*hlava[i][5];z6=jablko[i][6]*hlava[i][6];z7=jablko[i][7]*hlava[i][7];
        wait(0.0001);
      }
      if(i == 1){
    A=0;B=1;C=1;
    c0=had[i][0];c1=had[i][1];c2=had[i][2];c3=had[i][3];c4=had[i][4];c5=had[i][5];c6=had[i][6];c7=had[i][7];
    z0=jablko[i][0]*hlava[i][0];z1=jablko[i][1]*hlava[i][1];z2=jablko[i][2]*hlava[i][2];z3=jablko[i][3]*hlava[i][3];z4=jablko[i][4]*hlava[i][4];z5=jablko[i][5]*hlava[i][5];z6=jablko[i][6]*hlava[i][6];z7=jablko[i][7]*hlava[i][7];
    wait(0.0001);
      }
      if(i == 2){
    A=1;B=0;C=1;
        c0=had[i][0];c1=had[i][1];c2=had[i][2];c3=had[i][3];c4=had[i][4];c5=had[i][5];c6=had[i][6];c7=had[i][7];
        z0=jablko[i][0]*hlava[i][0];z1=jablko[i][1]*hlava[i][1];z2=jablko[i][2]*hlava[i][2];z3=jablko[i][3]*hlava[i][3];z4=jablko[i][4]*hlava[i][4];z5=jablko[i][5]*hlava[i][5];z6=jablko[i][6]*hlava[i][6];z7=jablko[i][7]*hlava[i][7];
        wait(0.0001);
      }
      if(i == 3){
    A=0;B=0;C=1;
        c0=had[i][0];c1=had[i][1];c2=had[i][2];c3=had[i][3];c4=had[i][4];c5=had[i][5];c6=had[i][6];c7=had[i][7];
        z0=jablko[i][0]*hlava[i][0];z1=jablko[i][1]*hlava[i][1];z2=jablko[i][2]*hlava[i][2];z3=jablko[i][3]*hlava[i][3];z4=jablko[i][4]*hlava[i][4];z5=jablko[i][5]*hlava[i][5];z6=jablko[i][6]*hlava[i][6];z7=jablko[i][7]*hlava[i][7];
        wait(0.0001);
      }
      if(i == 4){
    A=1;B=1;C=0;
    c0=had[i][0];c1=had[i][1];c2=had[i][2];c3=had[i][3];c4=had[i][4];c5=had[i][5];c6=had[i][6];c7=had[i][7];
    z0=jablko[i][0]*hlava[i][0];z1=jablko[i][1]*hlava[i][1];z2=jablko[i][2]*hlava[i][2];z3=jablko[i][3]*hlava[i][3];z4=jablko[i][4]*hlava[i][4];z5=jablko[i][5]*hlava[i][5];z6=jablko[i][6]*hlava[i][6];z7=jablko[i][7]*hlava[i][7];
    wait(0.0001);
      }
      if(i == 5){
    A=0;B=1;C=0;
        c0=had[i][0];c1=had[i][1];c2=had[i][2];c3=had[i][3];c4=had[i][4];c5=had[i][5];c6=had[i][6];c7=had[i][7];
        z0=jablko[i][0]*hlava[i][0];z1=jablko[i][1]*hlava[i][1];z2=jablko[i][2]*hlava[i][2];z3=jablko[i][3]*hlava[i][3];z4=jablko[i][4]*hlava[i][4];z5=jablko[i][5]*hlava[i][5];z6=jablko[i][6]*hlava[i][6];z7=jablko[i][7]*hlava[i][7];
        wait(0.0001);
      }
      if(i == 6){
    A=1;B=0;C=0;
        c0=had[i][0];c1=had[i][1];c2=had[i][2];c3=had[i][3];c4=had[i][4];c5=had[i][5];c6=had[i][6];c7=had[i][7];
     z0=jablko[i][0]*hlava[i][0];z1=jablko[i][1]*hlava[i][1];z2=jablko[i][2]*hlava[i][2];z3=jablko[i][3]*hlava[i][3];z4=jablko[i][4]*hlava[i][4];z5=jablko[i][5]*hlava[i][5];z6=jablko[i][6]*hlava[i][6];z7=jablko[i][7]*hlava[i][7];
         wait(0.0001);
      }
      if(i == 7){
    A=0;B=0;C=0;
        c0=had[i][0];c1=had[i][1];c2=had[i][2];c3=had[i][3];c4=had[i][4];c5=had[i][5];c6=had[i][6];c7=had[i][7];
        z0=jablko[i][0]*hlava[i][0];z1=jablko[i][1]*hlava[i][1];z2=jablko[i][2]*hlava[i][2];z3=jablko[i][3]*hlava[i][3];z4=jablko[i][4]*hlava[i][4];z5=jablko[i][5]*hlava[i][5];z6=jablko[i][6]*hlava[i][6];z7=jablko[i][7]*hlava[i][7];
        wait(0.0001);
      }
    }
  }
}
char dejs(char des,char jed)        // dle obdrzenych cisel zobrazi na displeji
{
  switch(jed){
    case 0: h[1] = 66; h[2] = 66; h[8] = 66; h[16] = 66; h[24] = 66; h[32] = 66; h[40] = 66; h[48] = 66;
            h[11] = 66; h[19] = 66; h[27] = 66; h[35] = 66; h[43] = 66; h[51] = 66; h[57] = 66; h[58] = 66;break;
    case 1: h[5-5] = 66; h[13-5] = 66; h[21-5] = 66; h[29-5] = 66; h[37-5] = 66; h[45-5] = 66; h[53-5] = 66; h[61-5] = 66;
            h[54-5] = 66; h[47-5] = 66;break;
    case 2: h[5-5] = 66; h[6-5] = 66; h[7-5] = 66; h[15-5] = 66; h[23-5] = 66; h[31-5] = 66; h[29-5] = 66; h[30-5] = 66;
            h[37-5] = 66; h[38-5] = 66; h[39-5] = 66; h[45-5] = 66; h[53-5] = 66; h[61-5] = 66; h[62-5] = 66; h[63-5] = 66;break;
    case 3: h[5-5] = 66; h[6-5] = 66; h[7-5] = 66; h[13-5] = 66; h[21-5] = 66; h[29-5] = 66; h[30-5] = 66; h[31-5] = 66;
            h[37-5] = 66; h[38-5] = 66; h[39-5] = 66; h[45-5] = 66; h[53-5] = 66; h[61-5] = 66; h[62-5] = 66; h[63-5] = 66;break;
    case 4: h[5-5] = 66; h[13-5] = 66; h[21-5] = 66; h[29-5] = 66; h[30-5] = 66; h[31-5] = 66; h[63-5] = 66;
            h[37-5] = 66; h[38-5] = 66; h[39-5] = 66; h[45-5] = 66; h[53-5] = 66; h[61-5] = 66; h[47-5] = 66; h[55-5] = 66;break;
    case 5: h[5-5] = 66; h[6-5] = 66; h[7-5] = 66; h[13-5] = 66; h[21-5] = 66; h[29-5] = 66; h[30-5] = 66; h[31-5] = 66; h[62-5] = 66;
            h[37-5] = 66; h[38-5] = 66; h[39-5] = 66; h[61-5] = 66; h[47-5] = 66; h[55-5] = 66; h[63-5] = 66;break;
    case 6: h[5-5] = 66; h[6-5] = 66; h[7-5] = 66; h[13-5] = 66; h[21-5] = 66; h[29-5] = 66; h[15-5] = 66; h[23-5] = 66; h[31-5] = 66; h[62-5] = 66;
            h[37-5] = 66; h[38-5] = 66; h[39-5] = 66; h[61-5] = 66; h[47-5] = 66; h[55-5] = 66; h[63-5] = 66;break;
    case 7: h[5-5] = 66; h[13-5] = 66; h[21-5] = 66; h[29-5] = 66; h[37-5] = 66; h[45-5] = 66; h[53-5] = 66; h[61-5] = 66;
            h[63-5] = 66; h[62-5] = 66;break;
    case 8: h[6-5] = 66; h[13-5] = 66; h[21-5] = 66; h[29-5] = 66; h[15-5] = 66; h[23-5] = 66; h[31-5] = 66; h[62-5] = 66;  h[45-5] = 66;
            h[38-5] = 66; h[45-5] = 66; h[53-5] = 66; h[47-5] = 66; h[55-5] = 66; h[53-5] = 66;break;
    case 9: h[5-5] = 66;h[13-5] = 66; h[21-5] = 66; h[29-5] = 66; h[31-5] = 66; h[62-5] = 66;  h[45-5] = 66;
            h[37-5] = 66; h[39-5] = 66; h[45-5] = 66; h[53-5] = 66; h[61-5] = 66; h[47-5] = 66; h[55-5] = 66; h[63-5] = 66; h[53-5] = 66;  h[30-5] = 66;break;
    default: h[0] = 66;
  }
  if(des !=0){
    switch(des){
      case 1: h[5] = 66; h[13] = 66; h[21] = 66; h[29] = 66; h[37] = 66; h[45] = 66; h[53] = 66; h[61] = 66;
              h[54] = 66; h[47] = 66;break;
      case 2: h[5] = 66; h[6] = 66; h[7] = 66; h[15] = 66; h[23] = 66; h[31] = 66; h[29] = 66; h[30] = 66;
              h[37] = 66; h[38] = 66; h[39] = 66; h[45] = 66; h[53] = 66; h[61] = 66; h[62] = 66; h[63] = 66;break;
      case 3: h[5] = 66; h[6] = 66; h[7] = 66; h[13] = 66; h[21] = 66; h[29] = 66; h[30] = 66; h[31] = 66;
              h[37] = 66; h[38] = 66; h[39] = 66; h[45] = 66; h[53] = 66; h[61] = 66; h[62] = 66; h[63] = 66;break;
      case 4: h[5] = 66; h[13] = 66; h[21] = 66; h[29] = 66; h[30] = 66; h[31] = 66; h[63] = 66;
              h[37] = 66; h[38] = 66; h[39] = 66; h[45] = 66; h[53] = 66; h[61] = 66; h[47] = 66; h[55] = 66;break;
      case 5: h[5] = 66; h[6] = 66; h[7] = 66; h[13] = 66; h[21] = 66; h[29] = 66; h[30] = 66; h[31] = 66; h[62] = 66;
              h[37] = 66; h[38] = 66; h[39] = 66; h[61] = 66; h[47] = 66; h[55] = 66; h[63] = 66;break;
      case 6: h[5] = 66; h[6] = 66; h[7] = 66; h[13] = 66; h[21] = 66; h[29] = 66; h[15] = 66; h[23] = 66; h[31] = 66; h[62] = 66;
              h[37] = 66; h[38] = 66; h[39] = 66; h[61] = 66; h[47] = 66; h[55] = 66; h[63] = 66;break;
    }
  }
  return 0;
}
    
char score(char body)        // rozdeli celkove skore na jednotky a desitky
{
  char sd,sj;
  
  sd = body/10;
  sj = body%10;
    
  dejs(sd,sj);
  return 0;
}  
    
void cekej()        // zobrazovaci funkce blikani hada pri zakousnuti
{
  short  i =0;
  while(i<50){
    ukaz();
    i++;
  }
}

int main()
{
  while(1){
    int i,k=0,kk=40,t1,t2;
    
    srand (time(NULL)+ran*1000);        //pro skoronahodnou posloupnost
  
    for(i=0;i<65;i++){      //nulovani pracovnich poli
      h[i] = 65;
      hh[i] = 65;
    }

    nuldisp();      //na zacatku vynuluj displej

    for (i = 0; i < size; i++){     //pocatecni delka hada v zobrazovaci matici
      had[0][i] = 0;
    }
    
    h[0]=2;h[1]=1;h[2]=0;       // pocatecni had v pracovnim poli
    genj();     //generovani jablka
      while(konec()){       //smycka vlastni hry
        tlac();         //obsluha tlacitek
        dejmat();       //prevod z prac do matic
        ukaz();         //zobrazeni matice
       
        if(100*tsi.readPercentage() > 10){      // ovladani rychlosti hada, pokud se dotknu slideru ulozi se aktualni hodnota do promene
          kk = 110-100*tsi.readPercentage();    // doleva pomalejsi doprava rychlejsi
        }
      
        if(k >= kk ){       // zajisteni pohybu hada danou rychlosti
          pohyb();
          chlamst();
          k = 0;
        }
        k++;
      }
  // zablikani hada pokud se zakousne
    nuldisp();
    cekej();
    dejmat();
    cekej();
    nuldisp();
    cekej();
    dejmat();
    cekej();
    nuldisp();
    cekej();
    nuldisp();
  
    score(s);   // prepocet skore
    for(i = 0; i <= 65; i++){       // prevedeni do maticove podoby
      if(h[i] == 66){
    t1 = i % 8;
    t2 = i / 8;
      had[t2][t1] = 0;
      }
    }
    while(1){       //smycka zobrazujici skore az do stisku reset nebo sipky nahoru
      ukaz();
      if(up ==0){
    size = 3;s=2;posun = 0;
    wait(0.5);
    break;
      }
    }
  }
}